<div class="edgar-toolbar edgar-sticky pl-3 pr-3">
    <div class="row d-flex justify-content-between align-items-baseline"
        style="border-bottom: 1px solid darkgray;">
        <div class="btn-group">
            <button class="btn btn-outline-success" left="12" right="0">1-0</button>
            <button class="btn btn-outline-success" left="4" right="8">1-2</button>
            <button class="btn btn-outline-success" left="6" right="6">1-1</button>
            <button class="btn btn-outline-success" left="8" right="4">2-1</button>
            <button class="btn btn-outline-success" left="0" right="12">0-1</button>
            <button class="btn btn-outline-success" left="12" right="12">Vert</button>
        </div>

        <div class="btn-group">
            <form id="frmUpload" action="/upload/tutorial/<%=tutorial_step.id_tutorial%>" method="POST"
                enctype="multipart/form-data">
                <div class="input-group">
                    <div class="custom-file">
                        <input type="file" class="custom-file-input" name="images" id="inputGroupFile02"
                            multiple='multiple' accept='image/*'>
                        <label class="custom-file-label" for="inputGroupFile02">Choose file(s)</label>
                    </div>
                    <div class="input-group-append">
                        <button class="btn btn-primary" type="submit">
                        <i class="fas fa-cloud-upload-alt"></i>
                        </button>
                    </div>
                    </div>
            </form>
        </div>

        <div class="btn btn-group">
            <a class="btn btn-primary<% if (tutorial_step.ordinal == 1) { %> disabled<% } %>"
                href="../<%- tutorial_step.ordinal - 1 %>/edit" title="Previous step">
                <i class="fa fa-arrow-left"></i>
            </a>
            <a class="btn btn-primary" href="../<%- tutorial_step.ordinal + 1 %>/edit" title="Next step">
                <i class="fa fa-arrow-right"></i>
            </a>
            <a class="btn btn-primary" href="../../edit" title="Exit step edit and return to tutorial definition">
                <i class="fas fa-sign-out-alt"></i>
            </a>
        </div>

        <form  method="POST">
        <div class="btn-group" role="group">
            <button class="btn btn-primary btn-saveinplace" type="submit" name="saveinplace" value="saveinplace">Save In Place</button>
            <button class="btn btn-danger btn-delete" type="submit" name="delete" value="delete"
                edgar_confirm_text="Do you really want to delete this?">
                Delete
            </button>
        </div>
    </div>

    <div class="row d-flex justify-content-between m-2">
        <div class="d-flex justify-content-start align-items-end">
            <div>
                <%  locals.combodata = {id:"id_code_runner", list:code_runners, name:"id_code_runner"}; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
            </div>
            <div>
                <%  locals.combodata = {id:"id_programming_language", list:programming_languages, name:"id_programming_language", attributes:"multiple"}; %>
                <%- include(`${locals.partialsRoot}/combo`) %>
            </div>
            <button class="btn btn-primary"
                type="button"
                id="btnAddPlayground">
                <i class="fas fa-plus-circle"></i>Playground
            </button>
        </div>
        <div class="d-flex align-items-end">
            <input type=" text" placeholder="1234"
                type="number" min="0" max="999999999" step="1"
                class="form-control" id="idQuestion"
                style="width:4rem;"
                />
            <button class="btn btn-primary"
                type="button"
                id="btnAddCodeQuestion">
                <i class="fas fa-plus-circle"></i>Code question
            </button>
            <button class="btn btn-primary"
                type="button"
                id="btnAddQuestion">
                <i class="fas fa-plus-circle"></i>Question
            </button>
        </div>
        <div class="d-flex align-items-end">
            <button class=" btn btn-primary"
                type="button"
                id="btnAddInlineAbc">
                <i class="fas fa-plus-circle"></i>inline ABC
            </button>
        </div>
        <div class="d-flex align-items-end">
            <button class=" btn btn-info"
                type="button"
                id="btnAddCollapsible">
                <i class="fas fa-plus-circle"></i>accordion
            </button>
        </div>
    </div>

</div>

<div class="card card-body d-flex justify-content-between">
    <div class="d-flex justify-content-between">
        <h3><%- tutorial_title %></h3>
        <h3><span class="badge badge-success">Step <%- tutorial_step.ordinal %></span></h3>
    </div>
</div>


<input type="hidden" name="tutorial_step[id]" value="<%- tutorial_step.id %>" />
<div class="container-fluid">

    <div class="row" >
        <div class="col-6 card card-body" id="preview-left">
            <div class="row">
                <div class="col-8">
                    <input type="text" required placeholder="Step title" class="form-control" name="tutorial_step[title]" value="<%- tutorial_step.title%>" />
                </div>
                <div class="col-4">
                    <a href="https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet" target="_blank">MD Cheat sheet</a>
                    <a href="http://www.tablesgenerator.com/markdown_tables" target="_blank">Tables generator</a>
                    <a href="https://jbt.github.io/markdown-editor/" target="_blank">Online editor</a>
                    <a href="https://arachnoid.com/latex/" target="_blank">Formulas editor</a>
                </div>
            </div>

            <div class="container-fluid card-body card">
                <textarea id="tutorial_step_text" name="tutorial_step[text]" data-a2-type="mdtext" style="min-height: 500px;"><%- tutorial_step.text %></textarea>
            </div>
        </div>
        <div class="col-6 card card-body" id="preview-right">
            <div class="row">
                <div class="col-3"><h4 class="card-title">Preview:</h4></div>
                <div class="col-4 offset-5"><button class="btn btn-outline-secondary float-right" type="button" id="btnSsRender" name="ssrender" value="ssrender" >Server-side render(formulas)</button></div>
            </div>
            <div id="preview" enhance-md data-a2-type="preview" data-a2-src="tutorial_step_text" class="container-fluid" style="border: 1px solid #D3D3D3;">
                Preview
            </div>

        </div>
    </div>
    <div class="container-fluid">
        <div class="row">
            <div class="card card-body">
                <h4 class="card-title">Step hints</h4>
                <p>Textual hints are provided on student request in the given order.</p>
                <div class="table-responsive">
                    <table id="stepHintsTable" class="table">
                            <thead>
                                <th style="width: 50px">Active</th>
                                <th style="width: 100px">Ordinal</th>
                                <th>Hint text</th>
                                <th>Hint preview</th>
                            </thead>
                            <tbody>
                                <% for(var i = 0; i < step_hints.length + 5; ++i) { %>
                                    <tr>
                                        <td>
                                            <input type="checkbox" name="step_hints[<%- i %>][is_active]" value="true"
                                                <% if (i >= step_hints.length || step_hints[i].is_active) { %>checked <% } %> />
                                        </td>
                                        <td>
                                            <% if (i < step_hints.length) { %>
                                                <input type="hidden" name="step_hints[<%- i %>][id]" value="<%- step_hints[i].id %>" />
                                            <% } %>
                                            <input type="number" class="form-control" min="1" max="100" name="step_hints[<%- i %>][ordinal]" value="<%- i < step_hints.length ? step_hints[i].ordinal : i + 1 %>" />
                                        </td>
                                        <td>
                                            <textarea id="step_hints_<%- i %>_hint_text" name="step_hints[<%- i %>][hint_text]" data-a2-type="code"><%- i < step_hints.length ? step_hints[i].hint_text : '' %></textarea>
                                        </td>
                                        <td>
                                            <div data-a2-type="preview" data-a2-src="step_hints_<%- i %>_hint_text"></div>
                                        </td>
                                    </tr>
                                <% } %>
                            </tbody>
                        </table>
                        <p class="text-muted">
                            To add more hints, save the step and 5 additional empty rows will appear.<br/>
                            To remove a hint, simply save it as an empty text.
                        </p>
                </div>
            </div>
        </div>
    </div>
</form>
</div>


<script>
    let plDict = {};
    <% for (let pl of programming_languages) { %>
    plDict[<%=pl.id%>] = `<%-pl.hello_world%>`;
    <%   }%>

    // const insertMarkup = (markup) => {
    //     const editor = mdTextEditors[0];
    //     if (editor) {
    //         let curr = editor.getCursor();
    //         if (curr) {
    //             editor.replaceRange(markup, curr);
    //         } else {
    //             editor.replaceRange(markup, CodeMirror.Pos(editor.lastLine()));
    //         }
    //         editor.save();
    //     }
    // };
    $("#btnAddPlayground").click(function (e) {
        var btn = $(this);
        e.preventDefault();

        const id_code_runner = $("#id_code_runner").val();
        if (!id_code_runner) {
            edgar.showInfoDialog("Please, select code runner first from the dropdown.", undefined, "Undefined code runner");
        }
        const idpl = $("#id_programming_language").val();
        if (!idpl || idpl.length === 0) {
            edgar.showInfoDialog("Please, select one or more programming languages from the dropdown.", undefined, "Undefined programming language.");
        }
        const markup = `
<!-- code-playground crid=${id_code_runner} langids=(${idpl})-->
    ${(plDict[idpl[0]] && plDict[idpl[0]].trim()) ? plDict[idpl[0]]: "hello world undefined :("}
<!-- /code-playground -->
            `;
        insertMarkup(markup);
    });

    $("#btnAddCodeQuestion").click(function (e) {
        var btn = $(this);
        e.preventDefault();
        const id_question = $("#idQuestion").val();
        if (!id_question) {
            edgar.showInfoDialog("Please, prvoide the question id (txtbox to the left).", undefined, "Undefined question id");
        }
        const markup = `
<!-- code-question qid=${id_question} required -->
    // inital code here, delete "required" attribute above if the question is optional
<!-- /code-question -->
`;
        insertMarkup(markup);
    });

    $("#btnAddQuestion").click(function (e) {
        var btn = $(this);
        e.preventDefault();
        const id_question = $("#idQuestion").val();
        if (!id_question) {
            edgar.showInfoDialog("Please, provide the question id (txtbox to the left).", undefined, "Undefined question id");
        }
        const markup = `
<!-- question qid=${id_question} required -->
    // inital code here, delete "required" attribute above if the question is optional
<!-- /question -->
`;
        insertMarkup(markup);
    });

    $("#btnAddInlineAbc").click(function (e) {
        var btn = $(this);
        e.preventDefault();
        const markup = `
<!-- multichoice required -->
Should I stay or should **I go**?
@@@
Stay
@@@
Go
@@@
Stall <!-- correct -->
<!-- /multichoice -->
`;
        insertMarkup(markup);
    });

    $("#btnAddCollapsible").click(function (e) {
        var btn = $(this);
        e.preventDefault();
        const markup = `
<!-- collapse title="Open for details..." -->
Details **here**...
<!-- /collapse -->
`;
        insertMarkup(markup);
    });
</script>

